/*
 * Copyright (c) 2005 by Romuald DELAVERGNE
 * It can be redistributed under the terms of the GNU General Public License.
*/
#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>
#include <dir.h>

void
exitOnError(char *msg) {
	perror(msg);
	exit(1);
}

int
main(int argc, char *argv[]) {
	void *buf;
	int handle, n, done;
	struct ffblk ffblk;
	char *prog = argv[0];

	buf = malloc(BUFSIZ);

	if (argc == 1) {
		printf("%s: too few parameters !\n", prog);
		printf("concatenate files and print on the standard output\n");
		printf("usage: %s FILE [FILE...]\n", prog);
		exit(0);
	}

	while (--argc > 0) {
		done = findfirst(*++argv, &ffblk, 0);
		while (!done) {
			if ((handle = _open(ffblk.ff_name, O_RDONLY|O_BINARY)) == -1) exitOnError(prog);
			while (!eof(handle))
				if ((n = _read(handle, buf, BUFSIZ)) == -1 || _write(1, buf, n) == -1)
					exitOnError(prog);
			_close(handle);
			done = findnext(&ffblk);
		}
	}
	return 0;
}
